From a870ac7724d0ac1ca70a6a6a4b0a7f32861061b2 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 29 2020 05:04:12 +0000
Subject: [PATCH 1854/2232] Handle extern time lifetimes followed by semicolon


---

diff --git a/syntax/parse.rs b/syntax/parse.rs
index 5c37570..65e07aa 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -615,7 +615,7 @@ fn parse_extern_verbatim(
             parse_type_alias(
                 cx, attrs, type_token, ident, lifetimes, input, lang, namespace,
             )
-        } else if lookahead.peek(Token![:]) {
+        } else if lookahead.peek(Token![:]) || lookahead.peek(Token![;]) {
             // type Opaque: Bound2 + Bound2;
             parse_extern_type_bounded(
                 cx, attrs, type_token, ident, lifetimes, input, lang, trusted, namespace,
@@ -690,33 +690,35 @@ fn parse_extern_type_bounded(
     trusted: bool,
     namespace: &Namespace,
 ) -> Result<Api> {
-    let colon_token: Token![:] = input.parse()?;
     let mut bounds = Vec::new();
-    loop {
-        match input.parse()? {
-            TypeParamBound::Trait(TraitBound {
-                paren_token: None,
-                modifier: TraitBoundModifier::None,
-                lifetimes: None,
-                path,
-            }) if if let Some(derive) = path.get_ident().and_then(Derive::from) {
-                bounds.push(derive);
-                true
-            } else {
-                false
-            } => {}
-            bound @ TypeParamBound::Trait(_) | bound @ TypeParamBound::Lifetime(_) => {
-                cx.error(bound, "unsupported trait");
+    let colon_token: Option<Token![:]> = input.parse()?;
+    if colon_token.is_some() {
+        loop {
+            match input.parse()? {
+                TypeParamBound::Trait(TraitBound {
+                    paren_token: None,
+                    modifier: TraitBoundModifier::None,
+                    lifetimes: None,
+                    path,
+                }) if if let Some(derive) = path.get_ident().and_then(Derive::from) {
+                    bounds.push(derive);
+                    true
+                } else {
+                    false
+                } => {}
+                bound @ TypeParamBound::Trait(_) | bound @ TypeParamBound::Lifetime(_) => {
+                    cx.error(bound, "unsupported trait");
+                }
             }
-        }
 
-        let lookahead = input.lookahead1();
-        if lookahead.peek(Token![+]) {
-            input.parse::<Token![+]>()?;
-        } else if lookahead.peek(Token![;]) {
-            break;
-        } else {
-            return Err(lookahead.error());
+            let lookahead = input.lookahead1();
+            if lookahead.peek(Token![+]) {
+                input.parse::<Token![+]>()?;
+            } else if lookahead.peek(Token![;]) {
+                break;
+            } else {
+                return Err(lookahead.error());
+            }
         }
     }
     let semi_token: Token![;] = input.parse()?;
@@ -740,7 +742,6 @@ fn parse_extern_type_bounded(
     );
 
     let name = pair(namespace, &ident, cxx_name, rust_name);
-    let colon_token = Some(colon_token);
 
     Ok(match lang {
         Lang::Cxx => Api::CxxType,
diff --git a/tests/ui/extern_type_generic.stderr b/tests/ui/extern_type_generic.stderr
index e710290..95faec6 100644
--- a/tests/ui/extern_type_generic.stderr
+++ b/tests/ui/extern_type_generic.stderr
@@ -3,9 +3,3 @@ error: extern type with generic type parameter is not supported yet
   |
 4 |         type Generic<T>;
   |                      ^
-
-error: expected `=` or `:`
- --> $DIR/extern_type_generic.rs:4:24
-  |
-4 |         type Generic<T>;
-  |                        ^
diff --git a/tests/ui/extern_type_lifetime_bound.stderr b/tests/ui/extern_type_lifetime_bound.stderr
index 05d430b..8c58050 100644
--- a/tests/ui/extern_type_lifetime_bound.stderr
+++ b/tests/ui/extern_type_lifetime_bound.stderr
@@ -3,9 +3,3 @@ error: lifetime parameter with bounds is not supported yet
   |
 4 |         type Complex<'a, 'b: 'a>;
   |                          ^^^^^^
-
-error: expected `=` or `:`
- --> $DIR/extern_type_lifetime_bound.rs:4:33
-  |
-4 |         type Complex<'a, 'b: 'a>;
-  |                                 ^

